//Scorm 1.2
var API = null;

(function( $ ) {

	function Scorm() {
	    this.max_tries = 7;
	    this.tries = 0;
	    this.lesson_status;
	}

	Scorm.prototype = {
		constract: Scorm,

		initAPI:function() {
			var obj = this;

			try {
				API = this.getAPI();
			} catch (error) {
				console.log('Failed to find ScormAPI');
				return false;
			}

		    if (API == null) {
		        //console.log("Cannot find API");
		        if(this.tries < this.max_tries) {
		        	this.tries++;
		        	setTimeout(function(){ obj.initAPI() }, 500);
		        	return false;
		        }
		    } else {
		    	//console.log("API loaded");
		        API.LMSInitialize("");
		        this.lesson_status = this.getStatus();
		        if(this.lesson_status != "completed")
					this.setStatus("incomplete");

				return true;
		    }
		},

		getAPI:function() {
			var scormApi = this.findAPI(window);

	        if ((scormApi == null) && (window.opener != null) && (typeof (window.opener) != "undefined"))
	            scormApi = this.findAPI(window.opener);

	        //if (scormApi == null)
	            //console.log("Unable to find an API adapter");

	        return scormApi;
		},

		findAPI:function(win) {

			try {
			    if(win.API);
			}
			catch(err) {
			    return null;
			} 

	        var apitries = 0;
	        while ((win.API == null) && (win.parent != null) && (win.parent != win)) {
	            apitries++;
	            if (apitries > 7) {
	                console.log("Error finding API -- too deeply nested.");
	                return null;
	            }
	            win = win.parent;
	        }

	        return win.API;
	       
	    },

		setProgress:function(progress) {
			if(!API) return;

			API.LMSSetValue("cmi.core.lesson_location",  progress);
		},

		setStatus:function(status) {
			if(!API) return;

			API.LMSSetValue("cmi.core.lesson_status",  status);
		},

		setData:function(data) {
			if(!API) return;
			
			API.LMSSetValue("cmi.suspend_data", escape(JSON.stringify(data)));
		},

		setScoreMin: function(min) {
			API.LMSSetValue("cmi.core.score.min", min);
		},

		setScoreMax: function(max) {
			API.LMSSetValue("cmi.core.score.max", max);
		},

		setScore:function(score) {
			if(!API) return;

			API.LMSSetValue("cmi.core.score.raw", score);
		},

		setInteractions:function(interactions) {
			if(!API) return;

			$.each(interactions, function(index, interaction) {
				var respose = interaction.response.toString();
				respose = respose.replace(/ /g,"_"); 
				API.LMSSetValue("cmi.interactions."+index+".id", interaction.id);
				API.LMSSetValue("cmi.interactions."+index+".type", "fill-in");
				API.LMSSetValue("cmi.interactions."+index+".student_response", respose);
				API.LMSSetValue("cmi.interactions."+index+".result", (interaction.result == "true") ? "correct" : "wrong");
			});
		},

		getProgress:function() {
			if(!API) return;

			return API.LMSGetValue("cmi.core.lesson_location");
		},	

		getStatus:function() {
			if(!API) return;

			return API.LMSGetValue("cmi.core.lesson_status");
		},

		getData:function() {
			if(!API || !API.LMSGetValue("cmi.suspend_data")) return;	

			return JSON.parse(unescape(API.LMSGetValue("cmi.suspend_data")));
		},

		getLearnerID:function() {
			if(!API) return;

			return API.LMSGetValue("cmi.core.student_id");
		},

		getLearnerName:function() {
			if(!API) return;
			
			return API.LMSGetValue("cmi.core.student_name");
		},

		getVersion:function() {
			return "scorm1.2";
		},

		terminateLMS:function() {
			if(!API) return;

			API.LMSFinish("");
		},
	}

	window.Scorm = Scorm;

}( jQuery ));
